#include <Wire.h>

#define LED_PIN 13 // Светодиод на плате подключен к этому пину
#define ADDR 0x33  // Адрес контроллера в режиме slave

volatile boolean flag = false; // Флаг посылки сообщения малинке как slave
 
void setup() {
  Wire.begin(ADDR); // Изначально контроллер работает в режиме slave
  Wire.onReceive(receiveEvent); // Обработка принятого по i2c сообщения
  pinMode(LED_PIN, OUTPUT); // Пин для индикации светодиодом
  pinMode(2, INPUT_PULLUP); // Внешнее прерывание от кнопки и подтяжка пина к +5V
  attachInterrupt(0, bclick, FALLING); // Обработка нажатия кнопки
}

void bclick() { // Обработчик нажатия кнопки
  if(!flag) flag = true; // Установим флаг посылки сообщения малинке-слейву
}

void receiveEvent(int howMany) { 
  flag = true; // Установим флаг посылки сообщения малинке-слейву
  while (1 < Wire.available()) { // Выбираем все присланное
    char c = Wire.read();
  }
}

void loop() {
  if(flag) { // Получена команда связаться с малинкой
    Wire.begin(); // Переходим в режим master
    Wire.beginTransmission(0x30); // Подготавливаем передачу данных малинке-слейву
    Wire.write(ADDR); // Шлем малинке байт со своим адресом
    Wire.endTransmission(); // Завершаем передачу данных
    Wire.begin(ADDR); // Переходим в режим slave
    digitalWrite(LED_PIN, HIGH); // Мигнем светодиодиком на плате
    delay(200);              
    digitalWrite(LED_PIN, LOW);
    flag = false;
  }
}
