# Тест на прием данных малинкой-слейвом
import time
import pigpio

addr = 0x30 # Адрес малинки как слейва на i2c шине

def i2c(id, tick): # Обработчик приема пакета контроллером BSC (=i2c) в режиме slave
  global pi
  s, b, d = pi.bsc_i2c(addr)
  if b:
    print(f'Прерывание от устройства с адресом 0x{d[0]:2x}')

pi = pigpio.pi()
if not pi.connected:
  exit()

e = pi.event_callback(pigpio.EVENT_BSC, i2c) # Установка обработчика событий BSC как slave
pi.bsc_i2c(addr) # Конфигурирование BSC как slave

try:
  while True:
    pass
except KeyboardInterrupt:
  print('Завершаем работу')
finally: # Дезактивируем BSC
  e.cancel()
  pi.bsc_i2c(0)
  pi.stop()
